# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/type/percent.proto, envoy/type/semantic_version.proto, envoy/type/http.proto, envoy/type/range.proto
# plugin: python-betterproto
from dataclasses import dataclass

import betterproto


class FractionalPercentDenominatorType(betterproto.Enum):
    HUNDRED = 0
    TEN_THOUSAND = 1
    MILLION = 2


class CodecClientType(betterproto.Enum):
    HTTP1 = 0
    HTTP2 = 1
    # [#not-implemented-hide:] QUIC implementation is not production ready yet.
    # Use this enum with caution to prevent accidental execution of QUIC code.
    # I.e. `!= HTTP2` is no longer sufficient to distinguish HTTP1 and HTTP2
    # traffic.
    HTTP3 = 2


@dataclass
class Percent(betterproto.Message):
    """Identifies a percentage, in the range [0.0, 100.0]."""

    value: float = betterproto.double_field(1)


@dataclass
class FractionalPercent(betterproto.Message):
    """
    A fractional percentage is used in cases in which for performance reasons
    performing floating point to integer conversions during randomness
    calculations is undesirable. The message includes both a numerator and
    denominator that together determine the final fractional value. *
    **Example**: 1/100 = 1%. * **Example**: 3/10000 = 0.03%.
    """

    # Specifies the numerator. Defaults to 0.
    numerator: int = betterproto.uint32_field(1)
    # Specifies the denominator. If the denominator specified is less than the
    # numerator, the final fractional percentage is capped at 1 (100%).
    denominator: "FractionalPercentDenominatorType" = betterproto.enum_field(2)


@dataclass
class SemanticVersion(betterproto.Message):
    """
    Envoy uses SemVer (https://semver.org/). Major/minor versions indicate
    expected behaviors and APIs, the patch version field is used only for
    security fixes and can be generally ignored.
    """

    major_number: int = betterproto.uint32_field(1)
    minor_number: int = betterproto.uint32_field(2)
    patch: int = betterproto.uint32_field(3)


@dataclass
class Int64Range(betterproto.Message):
    """
    Specifies the int64 start and end of the range using half-open interval
    semantics [start, end).
    """

    # start of the range (inclusive)
    start: int = betterproto.int64_field(1)
    # end of the range (exclusive)
    end: int = betterproto.int64_field(2)


@dataclass
class Int32Range(betterproto.Message):
    """
    Specifies the int32 start and end of the range using half-open interval
    semantics [start, end).
    """

    # start of the range (inclusive)
    start: int = betterproto.int32_field(1)
    # end of the range (exclusive)
    end: int = betterproto.int32_field(2)


@dataclass
class DoubleRange(betterproto.Message):
    """
    Specifies the double start and end of the range using half-open interval
    semantics [start, end).
    """

    # start of the range (inclusive)
    start: float = betterproto.double_field(1)
    # end of the range (exclusive)
    end: float = betterproto.double_field(2)
